<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit;
} // Exit if accessed directly
add_action('init', 'byconsolewooodtSetCookie', 1);

class APPMAKER_WC_Delivery_Date_Time{
    public function __construct() {
        add_filter( 'appmaker_wc_checkout_fields', array( $this, 'checkout_fields_response_fix' ), 10, 2 );
        add_filter('appmaker_wc_validate_checkout',array($this,'Validation_checkout'));
    }
    public function  Validation_checkout($return){
        $date = $return['byconsolewooodt_delivery_date'];
        preg_match("/([a-zA-z]{3}[\s][\d]{2}[\s][\d]{4}[\s][\d\:]+)[\s](.*)/i",$date,$new_date);
        $new_date = $new_date[1];
        $timezone = $new_date[2];
        $date = new DateTime($new_date, new DateTimeZone($timezone));
        $timestamp = $date->format('d-m-Y');
        $date=strtotime($timestamp);
       if($date == strtotime(date('d-m-Y'))){
           $timezone = date_default_timezone_get();
           date_default_timezone_set($timezone);
           $current_time = current_time('h:i A');
           $current_time = strtotime($current_time);
           if (strtotime($return['byconsolewooodt_delivery_time']) <= $current_time) {
               return new wp_error('invalid_time', "Please enter a valid time");
           }
       }

            return $return ;

    }
    
    public function get_delivery_intervals(){
        $from = get_option('byconsolewooodt_delivery_hours_from');
        $from = strtotime($from);
        $to = get_option('byconsolewooodt_delivery_hours_to');
        $to = strtotime($to);
        $return = array();
        do{
            $time = date('h:i A', $from);
            $return[$time] = $time;
            $from = strtotime("+15 minutes", $from);
        }while($from<=$to);


        /*   $timezone = date_default_timezone_get();
        date_default_timezone_set($timezone);

        $current_time = current_time('h:i A');
        $current_time = strtotime($current_time);

           foreach ($return as $from => $i) {
               if (strtotime($i) <= $current_time) {
                   unset($return[$from]);

               }

           }*/


        return $return;
    }

    public function checkout_fields_response_fix( $return, $section )
    {
        $additional_fields = array();
        $min_date=date('d-m-Y');
        $byconsolewooodt_delivery_time = ! empty( $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_time_field'] ) ? $byconsolewooodt_delivery_widget_cookie_array['byconsolewooodt_widget_time_field'] : false;
        // get cookie as array
        $stripped_out_byconsolewooodt_delivery_widget_cookie=stripslashes($_COOKIE['byconsolewooodt_delivery_widget_cookie']);
        $byconsolewooodt_delivery_widget_cookie_array=json_decode($stripped_out_byconsolewooodt_delivery_widget_cookie,true);
        if ( $section === 'order' ) {

            $additional_fields['byconsolewooodt_delivery_type'] = array(
                'type' => 'select',
                'label' => 'Order Type',
                'required' => true,
                'options' => array(
                    'levering' => 'Delivery',
                    'take_away' => 'Take away',
                ),
                'default' => 'choose oder type',
            );

            $additional_fields['byconsolewooodt_delivery_date'] = array(
                'type' => 'datepicker',
                'label' => __('Select Date'),
                'required' => true,
                'minDate'=>$min_date,
                'placeholder' => __('Select Date'),
                'default' =>$min_date,
            );
            $additional_fields['byconsolewooodt_delivery_time'] = array(
                'type' => 'select',
                'label' =>  __('Select Time'),
                'class'=>array('byconsolewooodt_delivery_time'),
                'required' => true,
                'placeholder' => __('Select Time'),
                'options'=>$this->get_delivery_intervals(),
            );
        }
        return array_merge( $additional_fields, $return );
    }
}
new APPMAKER_WC_Delivery_Date_Time();
